<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper
    PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
    "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="EventLogService">

  <select id="getAllEventLogs" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT uri as eventLog, globalConfigurationListener
    FROM VVC_ScopeEventLog 
  </select>
  
  <insert id="insert" parameterType="serializedEventLog" useGeneratedKeys="false" keyProperty="uri">
    INSERT INTO VVC_ScopeEventLog (uri, etag, eventReceiverUrl, globalConfigurationListener, data) 
    values (#{uri}, #{eTag}, #{eventReceiverUrl}, #{globalConfigurationListener}, #{data})
  </insert>
  
  <select id="select" parameterType="string" resultType="SerializedEventLog">
    SELECT uri, etag, data
    FROM VVC_ScopeEventLog
    WHERE uri = #{uri} 
  </select>
  
  <update id="update" parameterType="serializedEventLog">
    UPDATE VVC_ScopeEventLog SET
      etag = #{newETag},
      data = #{data}
    WHERE uri = #{uri} and etag = #{eTag}
  </update>
  
  <delete id="delete" parameterType="string">
	DELETE FROM VVC_ScopeEventLog WHERE uri = #{uri}  
  </delete>
  
  <select id="findEventLog" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT uri as eventLog   
    FROM VVC_ScopeEventLog
    WHERE eventReceiverUrl = #{eventReceiverUrl}
  </select>
  
  <select id="findEventLog_forSpace" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT uri as eventLog   
    FROM VVC_ScopeEventLog
    JOIN VVC_ScopeEventRestriction ON VVC_ScopeEventLog.uri = VVC_ScopeEventRestriction.eventLog
    WHERE eventReceiverUrl = #{eventReceiverUrl} AND VVC_ScopeEventRestriction.confSpace = #{confSpace}
  </select>
  
</mapper>
