/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){   
	
	dojo.provide("com.ibm.team.vvc.server.core.ui.configurations.steps.AddToWhat");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("jazz.ui.wizard.WizardStep");
	
	dojo.require('dojo.i18n');
	dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.configurations.steps", "AddToWhatMessages");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
	var notificationFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

	dojo.declare("com.ibm.team.vvc.server.core.ui.configurations.steps.AddToWhat", [jazz.ui.wizard.WizardStep, dijit._Widget, dijit._Templated], {
	
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/configurations/steps/templates/AddToWhat.html'),
		messages: dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.configurations.steps", "AddToWhatMessages"),
		widgetsInTemplate: false,
		_storageKey: null,
		_data: null,
		_size: {
			width: 600, 
			height: 235
		},
		
		_disconnects: null,
		_destroys: null,
		
		constructor: function(args){
			if(args && args.storageKey){
				this._storageKey = args.storageKey;
			}
			
			this._disconnects = [];
			this._destroys = [];
			
			// IE8 is doing something weird with sizes...
			if(dojo.isIE <= 8){
				this._size.height = 200;
			}
		},
		
		destroy: function(args){
			this.inherited(args);
			dojo.forEach(this._disconnects, function(handle){dojo.disconnect(handle);});
			dojo.forEach(this._destroys, function(obj){dojo.destroyRecursive(obj);});
		},
		
		postCreate: function(){
			this._data = dojo.fromJson(sessionStorage.getItem(this._storageKey));
			var title = this._data["input"]["configuration"]["title"];

			var addToWhereText = dojo.string.substitute(this.messages.addToWhere, {configurationName: title});
			dojo.attr(this.addToWhereLabel, "innerHTML", addToWhereText);
			
			this.stepTitle = this.messages.stepTitle;
			//this._disconnects.push(dojo.connect(this.addToExistingOrNew, "onclick", dojo.hitch(this, this.triggerButtonStateUpdate)));

		},
		
		focusStep: function(){
			this.setSize(this._size);
			this._data = dojo.fromJson(sessionStorage.getItem(this._storageKey));	
		},
				
		customOnNext: function(){
			if(this.addToExistingOrNew[0].checked){
				// Pass the newly created configuration back, but do not enter it.
				this._data.addToWhat = "existing";
			} else {
				// Pass the newly created configuration back, and enter it.
				this._data.addToWhat = "new";
			}
			
			//this._data.newConfiguration.title = this.getConfigurationTitle();
			sessionStorage.setItem(this._storageKey, dojo.toJson(this._data));
		},
				
		canFlipToNextPage: function(){
			return true;
		},

		
		onSelected: function(){
			//
		}

		
	});

})();