/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.configurations.GlobalConfigurationCompactRendering");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.util.iframe");
dojo.require("jazz.client.xhr");
dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");
var ConfigurationUiNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode");
var ConfigurationSpaceNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.UserUiNode");
var UserUiNode = com.ibm.team.vvc.shared.web.ui.util.UserUiNode;

dojo.require("com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationResource");

dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.configurations", "GlobalConfigurationCompactRenderingMessages");

dojo.declare("com.ibm.team.vvc.server.core.ui.internal.configurations.GlobalConfigurationCompactRendering", [dijit._Widget, dijit._Templated], {

	messages: dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.configurations", "GlobalConfigurationCompactRenderingMessages"),
	
	templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/configurations/templates/GlobalConfigurationCompactRendering.html'),
	
	postCreate: function() {
		this.inherited(arguments);
		
		if (location.search.length > 0) {
		var obj = dojo.queryToObject(location.search.substring(1));
		if (obj) {
			if (obj.configurationUri) {
				var context1 = {
					messages: this.messages,
					self: this
				};
			
				var parentConfig = new com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationResource();
				
				//if you are trying to access or debug from an independent ajax module, 
				//don't use VvcUtils.getVvcUri() because BootstrapProperties.FRONTSIDE_URL is not set
				//in that case, please use the commented code to obtain the contextRoot
				//var contextRootIndex = obj.configurationUri.lastIndexOf("/configurations/");
				//var contextRoot = obj.configurationUri.substring(0, contextRootIndex);
				var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + encodeURIComponent(obj.configurationUri);
				var deferred1 = parentConfig.loadAsync(link);

				deferred1.then(dojo.hitch(context1, function(configuration, ioArgs) {
						
						if (!configuration) {
							dojo.addClass(this.self.tableNode, "configuration-compact-rendering-hidden");
							dojo.addClass(this.self.errorNode, "configuration-compact-rendering-visible");
							return;
						}
						
						try {
							var description = configuration.getDescription();
							if (!description || description.length == 0) {
								description = this.messages.empty;
							}
							this.self.descriptionNode.appendChild(dojo.doc.createTextNode(description));
						} catch (err) {
							this.self.descriptionNode.appendChild(dojo.doc.createTextNode(this.messages.unknown));
						}
						
						this.self.configurationTypeNode.appendChild(dojo.doc.createTextNode(configuration.getMutable() ? this.messages.configurationTypeMutable : this.messages.configurationTypeImmutable));

						this.self.numberOfContributionsNode.appendChild(dojo.doc.createTextNode(configuration.getContributions() ? configuration.getContributions().length : 0));
						
						try {
							var userUiNode = new UserUiNode({
								uri: configuration.getCreator(),
								includeLink: false,
								includeHover: false
							});
							this.self.creatorNode.appendChild(userUiNode.domNode);
						} catch (err) {
							this.self.creatorNode.appendChild(dojo.doc.createTextNode(this.messages.unknown));
						}

						try {
							var created = new Date(configuration.getCreated());
							created = created.toLocaleDateString() + " " + created.toLocaleTimeString();
							this.self.createdNode.appendChild(dojo.doc.createTextNode(created));
						} catch (err) {
							this.self.createdNode.appendChild(dojo.doc.createTextNode(this.messages.unknown));
						}
						
					}),
					dojo.hitch(this, function(responseerror) {
						dojo.addClass(this.self.tableNode, "configuration-compact-rendering-hidden");
						dojo.addClass(this.self.errorNode, "configuration-compact-rendering-visible");
					}));
					
				} else {
					dojo.addClass(this.tableNode, "configuration-compact-rendering-hidden");
					dojo.addClass(this.errorNode, "configuration-compact-rendering-visible");
				}
			}
		
		}
		
		if (window.postMessage && window.parent) {
			var newPreviewHeight = jazz.util.iframe.getDocumentHeight();
			var resizeMessage = "oslc-preview-height:" + newPreviewHeight;
			window.parent.postMessage(resizeMessage, "*");
			resizeMessage = "jazz-compact-rendering-preview-height:" + newPreviewHeight;
			window.parent.postMessage(resizeMessage, "*");
		} 
	}
	
});

})();
