/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.GlobalConfigurationEditor");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.InlineEditBox");
	dojo.require("jazz.util.html");
	
	dojo.require('com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils');
	
	dojo.require("com.ibm.team.vvc.server.core.ui.snapshots.ContributionsViewer");
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationResource");
	
	dojo.require("com.ibm.team.vvc.server.core.globalConfigurations.pickers.ContributionsPickerDialog");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager");
		
	dojo.require("jazz.ui.ResourceLink");
	var ResourceLink = jazz.ui.ResourceLink;
	
	dojo.require("net.jazz.ajax.ui.PlatformUI");
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
	var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

	dojo.require("com.ibm.team.vvc.shared.web.ui.util.UIUtils");
	var UIUtils = com.ibm.team.vvc.shared.web.ui.util.UIUtils;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationConstants");
	var GlobalConfigurationConstants = com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationConstants;
		
	dojo.require("com.ibm.team.vvc.server.core.globalConfigurations.pickers.ContributionsPickerDialog");
	var ContributionsPickerDialog = com.ibm.team.vvc.server.core.globalConfigurations.pickers.ContributionsPickerDialog
			
	//TODO add when we are ready for permissions
	//dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");
	//var SecurityServiceUtils = com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget");
	
	dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "GlobalConfigurationEditorMessages");
	var messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "GlobalConfigurationEditorMessages");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	var vvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
	var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils");
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ListDialogContent");

	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.GlobalConfigurationEditor", [com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget, dijit._Templated], {

		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/page/templates/GlobalConfigurationEditor.html'),

		_editableTitle: null,
		_globalConfigurationUri: null,
		_globalConfiguration: null,
		_clmFriendsInfo: null,
		_makeImmutablePressed: false,
		_createMode: false,
		
		constructor: function() {
			this.messages = messages;
			var context = ContextUtils.getContextUri();
		},

		postCreate: function() {
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(vvcConstants.EDIT_GLOBAL_CONFIGURATION, this, "showPage");
			//ActionRegistry.registerAction(vvcConstants.EDIT_GLOBAL_CONFIGURATION_CONTRIBUTIONS, this, "showContributions");

			var onresizeHandle = dojo.connect(window, "onresize", this, this.onResize);
			this._initializeTabs();
			
			var ncc = new com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController();
			this.nccNode.appendChild(ncc.domNode);
			
			var authenticationDeferred = new dojo.Deferred();
			com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils.authenticate(authenticationDeferred, false, "vvc");

			authenticationDeferred.then(dojo.hitch(this, function(result) {
				this._clmFriendsInfo = result;
			}));
		},
		
		_initializeTabs: function()
		{
			this._tabManager = new com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager();
			var class_selectedTab= "Selected";
			this._tabManager.registerTab(this._tabOverview, this.overview_content, class_selectedTab, null, vvcConstants.WORKSPACES_OVERVIEW_TAB);
			this._tabManager.registerTab(this._tabDependencies, this.dependencies_content, class_selectedTab, dojo.hitch(this, function() { this._dependenciesViewer.load(this);}), vvcConstants.DEPENDENCIES_TAB);
			
			this._actionTabMap = [];
			this._actionTabMap[vvcConstants.WORKSPACES_OVERVIEW_TAB] = this._tabOverview;
			this._actionTabMap[vvcConstants.DEPENDENCIES_TAB] = this._tabDependencies;
			
			dojo.connect(this._tabManager, "tabActivated", dojo.hitch(this, this._updateTab));
		},
	   	
		showContributions: function()
		{
			this._renderPage();
		},
		
		showPage: function() {
			this._renderPage();
		},
		
		_renderPage: function() {
			this.hideMessage();
			this._initBreadcrumbs();
			this.addButtons();
			this._loadGlobalConfiguration();

			this._connectEventHandlers();
		},
		
				_onAddContribution: function() {
			var args = {
				clmFriendsInfo : this._clmFriendsInfo,
				onOk: dojo.hitch(this, function(newContributionUri) {
					
					var getArgs = {
							url: newContributionUri,
							headers: {
								"Accept" : "application/rdf+xml"
							},
							handleAs: "xml"
					};
					var dfd = jazz.client.xhrGet(getArgs);
					
					dfd.then(dojo.hitch(this, function(doc){
						var componentOfNewContributionUri = com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils.extractValue(doc, "component", GlobalConfigurationConstants.GC_NAMESPACE, "rdf:resource");
						var versionSkewResources = [], versionSkewResourceNames = [];
						
						if (this._globalConfiguration.getContributions()) {
							//does it already exist?
							
							var existingContributionResources = this._dependenciesViewer.getContributionResources();
							if (existingContributionResources) {
								for (var i = 0; i < existingContributionResources.length; i++) {
									for (key in existingContributionResources[i]) {
										if (key === newContributionUri) {
											//it was not added because it already exists
											com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showSimpleContentDialog(this.messages.configurationAlreadyExistsTitle, this.messages.configurationAlreadyExistsMessage);
											return;
										} else if (existingContributionResources[i][key].component[0].value === componentOfNewContributionUri) {
											versionSkewResourceNames.push(existingContributionResources[i][key].name[0].value);
											versionSkewResources.push(key);
										}
									}
								}
							}
							
							if (versionSkewResources.length === 1) {
								//ask if the user wants to replace, and maybe return
								var versionSkewQuestionMessage = dojo.string.substitute(this.messages.versionSkewQuestionMessage, { configurationName: versionSkewResourceNames[0] });
								com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showThreeButtonQuestionDialog(this.messages.versionSkewQuestionTitle, versionSkewQuestionMessage,
										this.messages.versionSkewQuestionReplaceButton, this.messages.versionSkewQuestionIntroduceVersionSkewButton, this.messages.versionSkewQuestionCancelButton,
										dojo.hitch(this, function() {
											var gcContributions = this._globalConfiguration.getContributions();
											var numberOfContributions = gcContributions.length;
											for (var i = 0; i < numberOfContributions; i++) {
		
												if (gcContributions[i].value === versionSkewResources[0]) {
													gcContributions.splice(i, 1);
													break;
												}
											}
											
											this._addContributionSaveAndRefresh(newContributionUri);						
										}), dojo.hitch(this, function() {
											this._addContributionSaveAndRefresh(newContributionUri);
										}) /*, dojo.hitch(this, function() {
											//don't do anything
										})*/ );
							} else {
								this._addContributionSaveAndRefresh(newContributionUri);
							}
							
							//don't ask if the length is 0 because there will not be version skew
							//and don't ask if the length is > 1 because there is already version skew
							
						} else {
							this._globalConfiguration.setContributions([newContributionUri]);
							
							var deferred = this._globalConfiguration.doSaveAsync();
							deferred.then(dojo.hitch(this, function (param) {
								//TODO put something in the notification bar and only refresh the table
								location.reload();
							}));
						}
						
					}));

					
				})
			};
			var picker = new com.ibm.team.vvc.server.core.globalConfigurations.pickers.ContributionsPickerDialog(args);
		},
		
		_addContributionSaveAndRefresh: function(newContributionUri) {
			this._globalConfiguration.getContributions().push({
				type: "uri",
				value: newContributionUri
			});
			
			var deferred = this._globalConfiguration.doSaveAsync();
			deferred.then(dojo.hitch(this, function (param) {
				//TODO put something in the notification bar and only refresh the table
				location.reload();
			}));						
		},
		
		_loadGlobalConfiguration: function()
		{
			if(this._isPageLoaded){
				return;
			}

			var context = ContextUtils.getContextUri();
				this._globalConfigurationUri = unescape(context);
				var globalConfig = new com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationResource();
				var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + this._globalConfigurationUri;
				var deferred = globalConfig.load(link, dojo.hitch(this, this.onLoadError));
				
				deferred.then(dojo.hitch(this, function (param) {
					this._globalConfiguration = globalConfig;
					
					var mutableOrImmutable = (globalConfig.getMutable()) ? "mutable" : "immutable";
					dojo.attr("editorIcon", "class", "icons-globalconfigurationeditor-global-configuration-" + mutableOrImmutable + "-header");
					this._globalConfigurationTypeNode.innerHTML = messages[mutableOrImmutable + "Editor"];
					
					this.updateMakeImmutableButton();

					this._isPageLoaded = true;

					this.refresh();
					this.enableActions();
					
					var hash = dojo.hash();
					if(hash){
						var hashObject = dojo.queryToObject(hash);
						this.enableActions();
						var tab = hashObject.tab;
						if(tab){
							for(var key in this._actionTabMap){
								if(tab === key){
									this._tabManager.showTab(this._actionTabMap[key]);
									return;
								}
							}
						}
						this._tabManager.showTab(this._tabOverview);
					}
					
				}), dojo.hitch(this, function(error) {
					this._handleError(error, deferred.ioArgs);
				}));
		},
		
		_connectEventHandlers: function() {
			this.connect(this._descriptionField,"onchange", function () {
				this.toggleSaveButton();
			});
		},
		
		_initEditableTitleNode: function(titleNode, title, tooltip){
			if (this._editableTitle) {
				this._editableTitle.setValue(title);
			}
			else
			{
				titleNode.innerHTML = jazz.util.html.escape(title);
				this._editableTitle = new dijit.InlineEditBox({
					title: tooltip, 
					autoSave: true, 
					width: "700px",
					noValueIndicator: this.getEditableTitleNodeDetails(), 
					editorParams: {maxLength: "60"}, 
					onFocus: dojo.hitch(this, this.hideMessage),
					onChange: dojo.hitch(this, this.onTitleChange)}, titleNode
				);
	
				dojo.addClass(this._editableTitle.domNode, "vvc-editor-editIndicator");
				this._editableTitle.startup();
			}
			this._editableTitle.originalValue = title;
		},
		
		setTitleValue: function(value){
			if(this._editableTitle){
				this._editableTitle.set('value', value);			
			}
		},

		onTitleChange: function(e){
			this.toggleSaveButton();
		},

		getEditableTitleNodeDetails: function(){
			return "?";
		},
		
		addButtons: function() {
			//TODO add snapshot and stream buttons here 

			var toolbar = dojo.byId("snapshot_editor_toolbar");
			if (!toolbar || toolbar.firstChild) {
				return;
			}
			var button = dojo.create("button");
			button.disabled = true;
			var buttonText = this.messages.save;
			button.style.minWidth = "80px";
			button.appendChild(dojo.doc.createTextNode(buttonText));
			dojo.connect(button, "onclick", this, "onSave");
			toolbar.appendChild(button);
			this._saveButton = button;
		},
		
		refresh: function() {
			// create and set title
			var title = this._globalConfiguration.getTitle();
			this._initEditableTitleNode(this._titleNode, title, this.messages.clickToEdit);
			
			// set description text
			this._descriptionField.value = this._globalConfiguration.getDescription();
			this._descriptionField.originalValue = this._descriptionField.value;
			
			this._configurationSpace.innerHTML = this._globalConfiguration.getComponent();
			
			
			var componentTitleDeferred = jazz.client.xhrGet({
				url: this._globalConfiguration.getComponent(),
    			headers: {
    				"accept": "application/rdf+xml"
    			},
    			handleAs: "xml"
			});
		
			componentTitleDeferred.then(dojo.hitch(this, function(result) {
				var title = com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils.extractTitle(result);
				if (title) {
					this._configurationSpace.innerHTML = title;
				}
			})); //no need for error: the url is already shown
			
			// build dependency viewer
			var dependenciesContainer = dojo.byId("dependencies_viewer_div");
			if (this._dependenciesViewer) {
				// refresh this view
				var node = this._dependenciesViewer.domNode;
				dependenciesContainer.removeChild(node);
			}
			
			var params = { lazyStart: true };
			if (this._globalConfiguration) {
				if (this._globalConfiguration.getMutable()) {
					params.style = 1; 
				}
				params.workspaceUri = this._globalConfiguration.uri; //eventually consider only the workspace parameter
				params.workspace = this._globalConfiguration.workspace;
				params.deleteFunction = dojo.hitch(this, function(contribResourceUri) {
					var contributions = this._globalConfiguration.getContributions()
					for (var i = 0; i < contributions.length; i++) {
						if (contributions[i].value === contribResourceUri) {
							contributions.splice(i, 1);
							break;
						}
					}
					
					var deferred = this._globalConfiguration.doSaveAsync();
					deferred.then(dojo.hitch(this, function (param) {
						//alert("it saved! " + data.addToExistingGlobalConfiguration.uri);
						//ideally put something in the notification bar now
						location.reload();
					}), dojo.hitch(this, function(param) {
						this.showMessage(PageUtil.createXhrErrorMessage(deferred.ioArgs));
					}));
					
				});
				params.replaceFunction = dojo.hitch(this, function(contribResourceUri) {
				var args = {
						dialogTitle: this.messages.replaceContributionDialogTitle,
						clmFriendsInfo : this._clmFriendsInfo,
						onOk: dojo.hitch(this, function(newContributionUri) {
							var contributions = this._globalConfiguration.getContributions();
							for (var i = 0; i < contributions.length; i++) {
								if (contributions[i].value === contribResourceUri) {
									contributions.splice(i, 1);
									break;
								}
							}								
							this._addContributionSaveAndRefresh(newContributionUri);
						})
					};
					var picker = new com.ibm.team.vvc.server.core.globalConfigurations.pickers.ContributionsPickerDialog(args);					
				});

//TODO: uncomment for automatic baseline functionality
//				params.replaceWithNewStreamAutoFunction = dojo.hitch(this, function(contribResourceUri) {
//					var contributions = [];
//					contributions.push(contribResourceUri);
//					this.doStreamOrBaselineOperation(contributions, "STREAM", dojo.hitch(this, function() {this.hideMessage();}));
//				});

//TODO: uncomment for automatic baseline functionality
//				params.replaceWithNewBaselineAutoFunction = dojo.hitch(this, function(contribResourceUri) {
//					var contributions = [];
//					contributions.push(contribResourceUri);
//					this.doStreamOrBaselineOperation(contributions, "BASELINE", dojo.hitch(this, function() {this.hideMessage();}));
//				});				
				
			}
			this._dependenciesViewer = new com.ibm.team.vvc.server.core.ui.snapshots.ContributionsViewer(params);
			dependenciesContainer.appendChild(this._dependenciesViewer.domNode);
						
			this._resourceLink = new ResourceLink({
				uri: this._globalConfiguration.getUri(),
				label: dojox.html.entities.encode(this._globalConfiguration.getTitle()),
				around: this.iconImg,
				lazyFetch: true
	    	});
		},
		
		_setFieldNameAndValue: function(field, fieldName, value) {
			if (field) {
				PageUtil.setLinkField(field, value);
				var tr = field.parentNode.parentNode;
				var textNode = tr.children[0].firstChild;
				textNode.nodeValue = fieldName;
			}
		},
		
		_extractValuesFromObjectArray: function(arr) {
			var result = [];
			for (var i = 0; arr && i < arr.length; i++) {
				result.push(arr[i].value);
			}
			return result;
		},
		
		onSave: function() {
			this.hideMessage();
			var title = this._editableTitle.value;
			var description = this._descriptionField.value;
			if (!title || title.length === 0) {
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					summary: this.messages.emptyName
				});
				return;
			}
			
			if (this._makeImmutablePressed) {
				this._makeImmutablePressed = false;
				com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showQuestionDialog(
						this.messages.makeImmutableQuestionTitle,
						this.messages.makeImmutableQuestionContent,
						this.messages.makeImmutableQuestionYes,
						this.messages.makeImmutableQuestionNo,
						dojo.hitch(this, this.doSave),
						dojo.hitch(this, this.backOutOfMakeImmutable));
			} else {
				this.doSave();
			}
		},
		
		doSave: function() {
			var title = this._editableTitle.value;
			var description = this._descriptionField.value;

			if (this._createMode) {
				var previousBaselines = this._extractValuesFromObjectArray(this._globalConfiguration.getPreviousBaselines());
				
				//if we are making a stream from an immutable configuration, we need to add the previous baseline
				if (!this._globalConfiguration.getMutable()) {
					previousBaselines.push(this._globalConfiguration.getUri());
				}

				var newGlobalConfigurationDetails = {
					title: title,
					description: description,
					component: this._globalConfiguration.getComponent(),
					mutable: true,
					previousBaselines: previousBaselines,
					contributions: this._extractValuesFromObjectArray(this._globalConfiguration.getContributions())
				};

				var newGlobalConfiguration = new com.ibm.team.vvc.shared.core.ui.objects.GlobalConfigurationResource(newGlobalConfigurationDetails);
				
				var deferred = newGlobalConfiguration.doCreate();
				deferred.then(dojo.hitch(this, function (param) {
					//don't use objectToQuery for simple strings
					window.location.href = VvcUtils.getVvcUri() + "/web?contextUri=" + encodeURIComponent(param) + "#action=editGlobalConfiguration";
				}));
				
			} else {
				this.disableActions();
				var deferred;
				UIUtils.showPageMessage(messages.saving);
				this._globalConfiguration.setTitle(title);
				this._globalConfiguration.setDescription(description);
				
				deferred = this._globalConfiguration.doSaveAsync();
				deferred.then(dojo.hitch(this, function(params){
					this.showMessage({
						type: jazz.ui.MessageBox.STATUS_TYPES.OK,
						summary: messages.saveSuccessful
					});
					this._editableTitle.originalValue = this._editableTitle.value;
					this._descriptionField.originalValue = this._descriptionField.value;
					this.enableActions();
					this.convertCreateButtonToSave();
					this.updateMakeImmutableButton();
					this._resourceLink.refresh();
				}), dojo.hitch(this, function(error) {
					this._handleError(error, deferred.ioArgs);
					this.enableActions();
				}));
			}			
		},
		
		updateMakeImmutableButton: function() {
			this._makeImmutableButton.set("visible", this._globalConfiguration.getMutable());
		},
		
		onLoadError: function(response, ioArgs) {
			this._handleError(response, ioArgs);
		},
		
		enableSaveButton: function()
		{
			if (this._saveButton) {
				this._saveButton.disabled = false;
				var node = dojo.byId("dirty");
				if (!node.firstChild) {
					node.appendChild(dojo.doc.createTextNode(" *"));
				}
			}
		},
		
		disableSaveButton: function()
		{
			if (this._saveButton) {
				this._saveButton.disabled = true;
				var node = dojo.byId("dirty");
				if (node.firstChild) 
					node.removeChild(node.firstChild);
				
				if (!this._globalConfiguration.getMutable()) {
					this._saveButton.title = this.messages.immutableTooltip;
				}			
			}
		},
		
		toggleSaveButton: function()
		{
			if (this.isDirty())
				this.enableSaveButton();
			else
				this.disableSaveButton();
		},
		
		convertSaveButtonToCreate: function() {
			this._createMode = true;
			this._saveButton.innerHTML = this.messages.create;
			dojo.attr(this._saveButton, "title", this.messages.createNewStreamTooltip);
		},
		
		convertCreateButtonToSave: function() {
			this._createMode = false;
			this._saveButton.innerHTML = this.messages.save;
		},
		
		enableActions: function()
		{
			//TODO when we are ready for permsisions:
//			if (this._globalConfiguration && (!this._globalConfiguration.permissionsLoaded || !this._globalConfiguration.permissions.createOrModifySnapshot)) {
//				if (this._globalConfiguration.permissionsLoaded) {
//					if (this._editableTitle) {
//						this._editableTitle.set("title", SecurityServiceUtils.getNoPermissionMessage(this._globalConfiguration.getProperty("controllingAreaName")));
//					}
//					if (this._descriptionField) {
//						this._descriptionField.title = SecurityServiceUtils.getNoPermissionMessage(this._globalConfiguration.getProperty("controllingAreaName"));
//					}
//				}
//				this.disableActions();
//				return;
//			}

			
			if (!this._globalConfiguration.getMutable()) {
				this.disableActions();
				return;
			}
			
			//the "duplicate stream" action is purposely excluded from enable /
			//disable because it's always enabled when visible
			
			this.toggleSaveButton();
			if (this._editableTitle) {
				this._editableTitle.setDisabled(false);
			}
			if (this._descriptionField) {
				this._descriptionField.disabled = false;
			}	
			if (this._editableTitle) {
				this._editableTitle.setDisabled(false);
			}
			if (this._descriptionField) {
				this._descriptionField.disabled = false;
			}
			if (this._addContributionButton) {
				this._addContributionButton.set("enabled", true);
			}			
			if (this._duplicateStreamButton) {
				this._duplicateStreamButton.set("enabled", true);
			}
		},
		
		disableActions: function()
		{
			//the "duplicate stream" action is purposely excluded from enable /
			//disable because it's always enabled when visible
			
			this.disableSaveButton();

			if (this._editableTitle) {
				this._editableTitle.setDisabled(true);
				if (!this._globalConfiguration.getMutable()) {
					this._editableTitle.set("title", this.messages.immutableTooltip);
				}			
			}
			if (this._descriptionField) {
				this._descriptionField.disabled = true;
				if (!this._globalConfiguration.getMutable()) {
					dojo.attr(this._descriptionField, "title", this.messages.immutableTooltip);
				}			
			}
			if (this._addContributionButton) {
				this._addContributionButton.set("enabled", false);
				if (!this._globalConfiguration.getMutable()) {
					this._addContributionButton.set("title", this.messages.immutableTooltip);
				}
			}

		},
		
		isDirty: function()
		{
			if (this._createMode) {
				return true;
			}
			else if (this._editableTitle && (this._editableTitle.value != this._editableTitle.originalValue))
				return true;
			else if (this._descriptionField && (this._descriptionField.value != this._descriptionField.originalValue))
				return true;
			return false;
		},
		
		onCreateStream: function() {
			this.enableSaveButton();
			this.convertSaveButtonToCreate();
			dojo.attr("editorIcon", "class", "icons-globalconfigurationeditor-global-configuration-mutable-header");
			this._globalConfigurationTypeNode.innerHTML = messages.mutableEditor;
			this._editableTitle.setDisabled(false);
			this._duplicateStreamButton.set("visible", false)
			this._editableTitle.setValue(this.messages.duplicatedConfigurationName);
			this._editableTitle.edit();
			this._editableTitle.set("title", this.messages.newStreamNameTooltip);
			dojo.attr(this._descriptionField, "title", "");
			this._addContributionButton.set("title", "");
			this._resourceLink.destroy();
		},
		
		_getCachedContributionNames: function(contributionUris) {
			var names = [];
			var existingContributionResources = this._dependenciesViewer.getContributionResources();
			for (var j = 0; j < contributionUris.length; j++) {
				var foundName = false;
				if (existingContributionResources) {
					for (var i = 0; i < existingContributionResources.length; i++) {
						if (existingContributionResources[i][contributionUris[j]]) {
							var name = existingContributionResources[i][contributionUris[j]].name;
							if (name && name[0] && name[0].value != null && name[0].value != undefined) { //empty ok
								names.push(name[0].value);
								foundName = true;
							}
							break;
						}
					}
				}
				if (!foundName) {
					names.push(contributionUris[j]);
				}
			}
			return names;
		},
		
		//called when the user presses any cancel button during the "make immutable" process or when a baseline can't be made
		backOutOfMakeImmutable: function() {
			this._makeImmutablePressed = false;
			this._duplicateStreamButton.set("enabled", true);
			this._makeImmutableButton.set("enabled", true);
			dojo.attr("editorIcon", "class", "icons-globalconfigurationeditor-global-configuration-mutable-header");
			this._globalConfigurationTypeNode.innerHTML = messages.mutableEditor;
			this.hideMessage();
		},
		
//TODO: uncomment for automatic baseline functionality
//		doStreamOrBaselineOperation: function(affectedContributions, operationType, backoutFunction, preSuccessFunction, preFailFunction) {
//			if (affectedContributions.length > 1) {
//				this.showMessage({
//					type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
//					summary: dojo.string.substitute(this.messages.automaticallyCreatingBaselines, { numberOfBaselines: affectedContributions.length })
//				});
//			} else {
//				this.showMessage({
//					type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
//					summary: (operationType === "BASELINE") ? this.messages.automaticallyCreatingBaseline : this.messages.automaticallyCreatingStream
//				});				
//			}
//			
//			var dfds = [];
//			for (var i = 0; i < affectedContributions.length; i++) {
//				var aDfd = new dojo.Deferred();
//				aDfd.affectedContribution = affectedContributions[i];
//				var getArgs = {
//					url: affectedContributions[i],
//					headers: {
//						"Accept" : "application/rdf+xml"
//					},
//					handleAs: "xml"
//				};
//				var dfd = jazz.client.xhrGet(getArgs);
//				var context = {
//					self: this,
//					contributionUri: affectedContributions[i],
//					aDfd: aDfd
//				};
//				dfds.push(aDfd);
//				dfd.then(dojo.hitch(context, function(result) {
//					var dl = com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils.extractAction(result, operationType);
//					
//					var context2 = {
//						self: this.self,
//						contributionUri: this.contributionUri,
//						aDfd: this.aDfd
//					}
//					dl.then(dojo.hitch(context2, function(result) {
//						
//						var operationSupportedByProvider = false;
//						if (result) {
//							for (i = 0; i < result.length; i++) {
//								if (result[i] && result[i][0] && result[i][1]) {
//									operationSupportedByProvider = true;
//									var args = {
//										headers: {
//											"Content-Type" : "text"
//										},
//										url: result[i][1],
//										postData: this.contributionUri,
//										load: function(response, ioArgs) {
//											if (ioArgs) {
//												var xhr = ioArgs.xhr;
//												if (xhr) {
//													return xhr.getResponseHeader("Location");
//												}
//											}
//										}
//									};
//									var post = jazz.client.xhrPost(args);
//									post.then(dojo.hitch(this, function(result) {
//										this.aDfd.resolve( { "result" : result, "affectedContribution" : this.aDfd.affectedContribution });
//									}), dojo.hitch(this, function(result) {
//										this.aDfd.reject( { "error" : this.contributionUri } );
//									}));
//								}
//							}
//						}
//						
//						if (!operationSupportedByProvider) {
//							//action not supported by provider
//							this.aDfd.reject( { "error" : this.contributionUri });
//						}
//						
//					}), dojo.hitch(this, function(result) {
//						this.aDfd.reject( { "error" : this.contributionUri });
//					}));
//					
//				}), dojo.hitch(this, function(result) {
//					this.aDfd.reject( { "error" : result });
//				}));
//			}
//			
//			var baseliningDeferredList = new dojo.DeferredList(dfds);
//			baseliningDeferredList.then(dojo.hitch(this, function(result) {
//				var failed = [];
//				var success = [];
//				var gcContributions = this._globalConfiguration.getContributions();
//				var numberOfContributions = gcContributions.length;
//
//				for (i = 0; i < result.length; i++) {
//					if (result[i] && result[i][0] && result[i][1]) {
//						//swap result[i][1].affectedContribution with result[i][1].result
//						for (var j = 0; j < numberOfContributions; j++) {
//							if (gcContributions[j].value === result[i][1].affectedContribution) {
//								gcContributions.splice(j, 1, {
//									type: "uri",
//									value: result[i][1].result
//								});
//								success.push(result[i][1].result);
//								break;
//							}
//						}
//					} else {
//						failed.push(result[i][1].error);
//					}
//				}
//				
//				if (failed.length == 0) {
//					if (preSuccessFunction) {
//						preSuccessFunction();
//					}
//					var deferred = this._globalConfiguration.doSaveAsync();
//					deferred.then(dojo.hitch(this, function (param) {
//						//TODO put something in the notification bar and only refresh the table
//						location.reload();
//					}));						
//				} else {
//					var failedNames = this._getCachedContributionNames(failed);
//					if (preFailFunction) {
//						preFailFunction(success, failedNames);
//					}
//
//					if (backoutFunction) {
//						backoutFunction();
//					}
//					
//					var title, description, solution; 
//					if (!preFailFunction) {
//						var baseline = operationType === "BASELINE";
//						title = dojo.string.substitute(this.messages.unableToStreamOrBaselineError, { streamOrBaseline: baseline ? this.messages.unableToStreamOrBaselineABaseline : this.messages.unableToStreamOrBaselineAStream, contributionName: failedNames[0] });
//						description = dojo.string.substitute(this.messages["unableToStreamOrBaselineError.explanation"], { contributionName: failedNames[0], streamOrBaseline: baseline ? this.messages.unableToStreamOrBaselineABaseline : this.messages.unableToStreamOrBaselineAStream, oppositeOfStreamOrBaseline : baseline ? this.messages.unableToStreamOrBaselineAStream : this.messages.unableToStreamOrBaselineABaseline });
//						solution = this.messages["unableToStreamOrBaselineError.useraction"];
//					} else {
//						title = this.messages.unableToBaselineAnyError;
//						description = this.messages["unableToBaselineAnyError.explanation"];
//						solution = this.messages["unableToBaselineAnyError.useraction"];
//						
//						var blockingResources = dojo.create("span");
//						var list = dojo.create("textarea", {
//							style: "width: 850px; height: 100px",
//							readonly: true
//						});
//						dojo.forEach(failedNames, dojo.hitch(this, function(failedName){
//							list.appendChild(dojo.doc.createTextNode(failedName + "\n"));
//						}));
//						blockingResources.appendChild(dojo.doc.createTextNode(description));
//						blockingResources.appendChild(dojo.create("br"));
//						blockingResources.appendChild(list);
//						description = blockingResources.outerHTML;
//					}
//					
//					ncFactory.createError({
//						"title": title,
//						"description": description,
//						"solution": solution
//					}).dispatch();
//
//				}
//				
//			}), dojo.hitch(this, function(result) {
//				if (backoutFunction) {
//					backoutFunction();
//				}
//			}));
//		},
		
		onMakeImmutable: function() {
			dojo.attr("editorIcon", "class", "icons-globalconfigurationeditor-global-configuration-immutable-header");
			this._globalConfigurationTypeNode.innerHTML = messages.immutableEditor;
			this._duplicateStreamButton.set("enabled", false);
			this._makeImmutableButton.set("enabled", false);

			var mutableContributions = [];
			var existingContributionResources = this._dependenciesViewer.getContributionResources();
			if (existingContributionResources) {
				for (var i = 0; i < existingContributionResources.length; i++) {
					for (key in existingContributionResources[i]) {
						if (existingContributionResources[i][key].mutable[0].value === "true") {
							mutableContributions.push(key);
						}
					}
				}
			}

			if (mutableContributions.length > 0) {
				mutableContributions = this._getCachedContributionNames(mutableContributions);
				var title = this.messages.unableToBaselineAnyError;
				var explanation = this.messages["unableToBaselineAnyError.explanation"];
				var solution = this.messages["unableToBaselineAnyError.useraction"];
				
				var blockingResources = dojo.create("span");
				var list = dojo.create("textarea", {
					style: "width: 850px; height: 100px",
					readonly: true
				});
				dojo.forEach(mutableContributions, dojo.hitch(this, function(mutableContribution){
					list.appendChild(dojo.doc.createTextNode(mutableContribution + "\n"));
				}));
				blockingResources.appendChild(dojo.doc.createTextNode(explanation));
				blockingResources.appendChild(dojo.create("br"));
				blockingResources.appendChild(list);
				var description = blockingResources.outerHTML;				
				
				ncFactory.createError({
					"title": title,
					"description": description,
					"solution": solution
				}).dispatch();

//TODO: uncomment for automatic baseline functionality
//				com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showQuestionDialog(
//						this.messages.mutableContributionsDetectedQuestionTitle,
//						this.messages.mutableContributionsDetectedQuestionContent,
//						this.messages.mutableContributionsDetectedMakeImmutable,
//						this.messages.mutableContributionsDetectedCancel,
//						dojo.hitch(this, this.doStreamOrBaselineOperation, mutableContributions, "BASELINE", dojo.hitch(this, this.backOutOfMakeImmutable),
//							dojo.hitch(this, function() { //preSuccessFunction
//								this._globalConfiguration.setMutable(false);
//							}),
//							dojo.hitch(this, function(success, failedNames) { //preFailFunction
//								com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showDialog(com.ibm.team.vvc.shared.web.ui.util.ListDialogContent, this.messages.unableToBaselineTitle, {message: this.messages.unableToBaselineContent, list: failedNames}, dojo.hitch(this, function() {
//									//why bother saving if we couldn't baseline any of the contributions?
//									//the gc would be exactly the same if success.length == 0
//									if (success.length > 0) {
//										var deferred = this._globalConfiguration.doSaveAsync();
//										deferred.then(dojo.hitch(this, function (param) {
//											//TODO put something in the notification bar and only refresh the table
//											location.reload();
//										}));						
//									}
//								}));
//						})), dojo.hitch(this, function() {
//							//user pressed cancel when asked to make contributions immutable
//							this.backOutOfMakeImmutable();
//						}));
			} else {
				this._globalConfiguration.setMutable(false);
				this._makeImmutablePressed = true;
				this.onSave();
				this._duplicateStreamButton.set("enabled", true);
			}
		}
		
	})
})();
