/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.SnapshotEditor");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.InlineEditBox");
	dojo.require("jazz.util.html");
	
	dojo.require("jazz.app.ua.PageHoverHelp");
	
	dojo.require("com.ibm.team.vvc.server.core.ui.snapshots.WorkspacesAndSnapshotsViewer");
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer");
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource");
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationSpace");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager");
		
	dojo.require("net.jazz.ajax.ui.PlatformUI");
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
	var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

	dojo.require("com.ibm.team.vvc.shared.web.ui.util.UIUtils");
	var UIUtils = com.ibm.team.vvc.shared.web.ui.util.UIUtils;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");
	var SecurityServiceUtils = com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");
	var ConfigurationUiNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode");
	var ConfigurationSpaceUiNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode");
	var ControllingAreaNode = com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget");
	
	dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "WorkspaceEditorMessages");
	var messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "WorkspaceEditorMessages");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	var vvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
	var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

	dojo.require("jazz.ui.ResourceLink");
	var ResourceLink = jazz.ui.ResourceLink;
	
	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.SnapshotEditor", [com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget, dijit._Templated], {

		iconUrl: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/add.gif'),
		
		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/page/templates/SnapshotEditor.html'),

		_editableTitle: null,
		_snapshotUri: null,
		_snapshot: null,
		_parentUri: null,
		_parentConfig: null,
		_isCreateOperation: false,
		_editingSnapshot: null,
		_createCompleted: false,
		_style: null,
		
		constructor: function() {
			this.messages = messages;
			this._style = PageUtil.getRequestParmValue("style");
			if (!this._style) {
				var context = ContextUtils.getContextUri();
			}
			this.snapshotIconUrl = dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/snapshot.gif');
		},

		postCreate: function() {
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(vvcConstants.EDIT_SNAPSHOT, this, "showPage");
			ActionRegistry.registerAction(vvcConstants.CREATE_SNAPSHOT, this, "showCreateSnapshot");
			
			var onresizeHandle = dojo.connect(window, "onresize", this, this.onResize);
			this._initializeTabs();
			
			var ncc = new com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController();
			this.nccNode.appendChild(ncc.domNode);
		},
		
		_initializeTabs: function()
		{
			this._tabManager = new com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager();
			var class_selectedTab= "Selected";
			this._tabManager.registerTab(this._tabOverview, this.overview_content, class_selectedTab, null, vvcConstants.WORKSPACES_OVERVIEW_TAB);
			this._tabManager.registerTab(this._tabDimensions, this.dimensions_content, class_selectedTab, null, vvcConstants.DIMENSIONS_TAB);
			this._tabManager.registerTab(this._tabDependencies, this.dependencies_content, class_selectedTab, dojo.hitch(this, function() { this._dependenciesViewer.load(this);}), vvcConstants.DEPENDENCIES_TAB);
			
			this._actionTabMap = [];
			this._actionTabMap[vvcConstants.WORKSPACES_OVERVIEW_TAB] = this._tabOverview;
			this._actionTabMap[vvcConstants.DIMENSIONS_TAB] = this._tabDimensions;
			this._actionTabMap[vvcConstants.DEPENDENCIES_TAB] = this._tabDependencies;

			// Only show the resources tab in debug mode, see WI43979
			if(dojo.config.isDebug){
				this._tabManager.registerTab(this._tabResources, this.resources_content, class_selectedTab, dojo.hitch(this, function() { this._resourceMappingTable.load(this);}), vvcConstants.RESOURCES_TAB);
				this._actionTabMap[vvcConstants.RESOURCES_TAB] = this._tabResources;
			} else {
				dojo.destroy(this._tabResources);
			}	
			
			dojo.connect(this._tabManager, "tabActivated", dojo.hitch(this, this._updateTab));
		},
		
		_initializeCSH: function() {
			if (this._ua != null)
				this._pageHeader.removeChild(this._ua.domNode);
	   		if (this._isCreateOperation)
				cshKey =  "com.ibm.team.vvc.server.core.page_SnapshotEditorCreate001";
			else
				cshKey =  "com.ibm.team.vvc.server.core.page_SnapshotEditorEdit001";
			this._ua = new jazz.app.ua.PageHoverHelp({uaKey: cshKey});
			this._pageHeader.appendChild(this._ua.domNode);
			this._ua.domNode.style.margin = "0px 0px 0px 5px";	
	   	},
	   	
		showCreateSnapshot: function()
		{
			this._isCreateOperation = true;
			this._renderPage();
		},
		
		showPage: function() {
			this._isCreateOperation = PageUtil.isCreate();
			this._renderPage();
		},
		
		_hideNonCreationTabs: function()
		{
			this._tabDependencies.style.display = "none";
			this._tabResources.style.display = "none";
		},
		
		_renderPage: function() {
			this.hideMessage();
			this._initializeCSH();
			this._initBreadcrumbs();
			this.addButtons();
			this._initSnapshot();
			
			if (this._isCreateOperation) {
				this._hideNonCreationTabs();
				
				this._initEditableTitleNode(this._titleNode, this.messages.newSnapshotName, this.messages.clickToEdit);
				
				// initialize the parent snapshot field
				var context = ContextUtils.getContextUri();
				if (context) {
					this._parentUri = unescape(context);
					this._parentConfig = this._getConfiguration(this._parentUri);
					parentName = this._parentConfig.getTitle();
				} else {
					parentName = "";
				}
				
				this._clearParentContext();
				
				if (this._parentUri) {
					this.setParentWorkspaceField(this._parentUri);
				}
				
				// build content of dimension tab
				var dimensions = [];
				var dimension = {};
				dimension.value = messages.purpose + "\n" + parentName;
				dimensions.push(dimension);
				this._buildDimensionTab(dimensions);
				
				// clear description field for new snapshot
				if (this._descriptionField && this._descriptionField.value) {
					this._descriptionField.value = "";
				}
				
				dojo.empty(this._controllingArea);
				var controllingAreaNode = new ControllingAreaNode({
					uri: this._parentConfig.getProperty("controllingAreaUri"),
					title: this._parentConfig.getProperty("controllingAreaName")
				});
				this._controllingArea.appendChild(controllingAreaNode.domNode);
			} else {
				dojo.empty(this._controllingArea);
				var controllingAreaNode = new ControllingAreaNode({
					uri: this._snapshot.getProperty("controllingAreaUri"),
					title: this._snapshot.getProperty("controllingAreaName")
				});
				this._controllingArea.appendChild(controllingAreaNode.domNode);
			}
			
			this._connectEventHandlers();
			
			this._updateSpaceField();
		},

		_buildDimensionTab: function(dimensions) {
			// create table
			var columnData = [{ label: this.messages.name }, { label: this.messages.value }];
			var container = this._dimensionContainerNode;
			if (container && container.firstChild) {
				container.removeChild(container.firstChild);
			}
			
			// create table header
			var table = new jazz.ui.StyledTable({
				trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS,
				columns: columnData
			});
			table.domNode.style.width = "100%";
			container.appendChild(table.domNode);
			
			if (!dimensions || dimensions.length == 0) {
				return;
			}

			// Now add the rows
			for (var i = 0; i < dimensions.length; i++){
				var nameValuePair = dimensions[i].value;
				var index = nameValuePair.indexOf("\n");
				if (index === -1) {
					continue;
				}
				
				var name = nameValuePair.substring(0, index);
				var value = nameValuePair.substring(index + 1);
				
				if("Time Order" === name){
					var time = new Date(value);
					value = time.toLocaleDateString() + " " + time.toLocaleTimeString();
					name = messages.timeOrderDimension;
				} else if("Purpose" === name){
					name = name = messages.purposeDimension;
				}
				
				var tr = dojo.create("tr", null, table.tbody);
				var titleTd = dojo.create("td", {
					innerHTML: name
				}, tr);
				var valueTd = dojo.create("td", {
					innerHTML: jazz.util.html.escape(value)
				}, tr);
			}
			
			return table;
		},
		
		_clearParentContext: function() {
			while (this._parentContext.hasChildNodes()) {
				this._parentContext.removeChild(this._parentContext.lastChild);
			}
		},
		
		_initSnapshot: function()
		{
			var context = ContextUtils.getContextUri();
			if (this._isCreateOperation) {
				this._parentUri = unescape(context);
			} else {
				this._snapshotUri = unescape(context);
				var snapshot = new com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource();
				var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + this._snapshotUri;
				var deferred = snapshot.load(link, dojo.hitch(this, this.onLoadError));
				
				link = VvcUtils.getVvcUri() + "/security/getAllPermissions?configurationUri=" + this._snapshotUri;
				var deferred2 = snapshot.loadPermissions(link, dojo.hitch(this, this.onLoadError));
				
				deferred.addCallback(this, function (param) {
					this._snapshot = snapshot;
				});
				deferred.addErrback(this, function(error) {
					this._handleError(error, deferred.ioArgs);
				});
				
				var dl = new dojo.DeferredList([deferred, deferred2]);
				dl.then(dojo.hitch(this, function (param) {
					if(this._isPageLoaded){
						return;
					}
					this._isPageLoaded = true;

					this.refresh();
					this.enableActions();
					
					var hash = dojo.hash();
					if(hash){
						var hashObject = dojo.queryToObject(hash);
						this.enableActions();
						var tab = hashObject.tab;
						if(tab){
							for(var key in this._actionTabMap){
								if(tab === key){
									this._tabManager.showTab(this._actionTabMap[key]);
									return;
								}
							}
						}
						this._tabManager.showTab(this._tabOverview);
					}
				
				}));				
			}
		},
		
		_updateSpaceField: function()
		{
			dojo.empty(this._configurationSpace);
			
			var spaceUri = PageUtil.getRequestParmValue("spaceUri");			
			spaceUri = spaceUri ? unescape(spaceUri) : this._snapshot.getSpaceUri()
			
			var spaceNode = new ConfigurationSpaceUiNode({uri: spaceUri});
			this._configurationSpace.appendChild(spaceNode.domNode);
		},
		
		_connectEventHandlers: function() {
			this.connect(this._descriptionField, "onkeyup", function (event) {
				var descriptionInput = this._descriptionField.value;
				var validText = dojo.trim(descriptionInput);
				// A description is not necessary so we accept !validText.length
				if(validText && validText.length <= 4000){
					this.toggleSaveButton();
				} else {
					var notification = ncFactory.createError({
						title: this.messages.errorDescriptionTooLong,
						description: this.messages["errorDescriptionTooLong.explanation"],
						solution: this.messages["errorDescriptionTooLong.userAction"],
						closeOnEvent: {
							context: this._descriptionField, 
							event: "onkeyup"
						}
					});
					notification.dispatch();
				}			
				this._descriptionField.focus();
			});
		},
		
		_initEditableTitleNode: function(titleNode, title, tooltip){
			if (this._editableTitle) {
				this._editableTitle.setValue(title);
			}
			else
			{
				titleNode.innerHTML = jazz.util.html.escape(title);
				this._editableTitle = new dijit.InlineEditBox({
					title: tooltip, 
					autoSave: true, 
					width: "700px",
					noValueIndicator: this.getEditableTitleNodeDetails(), 
					editorParams: {maxLength: "60"}, 
					onFocus: dojo.hitch(this, this.hideMessage),
					onChange: dojo.hitch(this, this.onTitleChange)}, titleNode
				);
	
				dojo.addClass(this._editableTitle.domNode, "vvc-editor-editIndicator");
				this._editableTitle.startup();
			}
			this._editableTitle.originalValue = title;
		},
		
		setTitleValue: function(value){
			if(this._editableTitle){
				this._editableTitle.set('value', value);			
			}
		},

		onTitleChange: function(e){
			this.toggleSaveButton();
		},

		getEditableTitleNodeDetails: function(){
			return "?";
		},
		
		addButtons: function() {
			var toolbar = dojo.byId("snapshot_editor_toolbar");
			if (!toolbar || toolbar.firstChild) {
				return;
			}
			var button = dojo.create("button");
			button.disabled = true;
			var buttonText = this.messages.saveAndClose;
			if (this._isCreateOperation) {
				buttonText = this.messages.create;
			}
			button.style.minWidth = "80px";
			button.appendChild(dojo.doc.createTextNode(buttonText));
			dojo.connect(button, "onclick", this, "onSave");
			toolbar.appendChild(button);
			this._saveButton = button;
		},
		
		lastSegment: function(uri) {
			var i = uri.lastIndexOf('/');
			if (i !== -1) {
				var s = uri.substring(i+1);
				return s;
			}
			return "";
		},
		
		refresh: function() {
			if (this._snapshot.isArchived()) {
				alert(messages.unableToOpenArchived);
				window.location.assign(VvcUtils.getVvcUri());
				return;
			}
			
			// initialize the parent snapshot field
			this._parentUri = this._snapshot.getParentWorkspaceUri();
			this.setParentWorkspaceField(this._parentUri);
			
			// create and set title
			var title = this._snapshot.getTitle();
			this._initEditableTitleNode(this._titleNode, title, this.messages.clickToEdit);
			
			// set description text
			this._descriptionField.value = this._snapshot.getDescription();
			this._descriptionField.originalValue = this._descriptionField.value;
			
			// build dimension viewer
			this._buildDimensionTab(this._snapshot.getDimensions());
			
			// build dependency viewer
			var dependenciesContainer = dojo.byId("dependencies_viewer_div");
			if (this._dependenciesViewer) {
				// refresh this view
				var node = this._dependenciesViewer.domNode;
				dependenciesContainer.removeChild(node);
			}
			
			var params = { style: 3, lazyStart: true };
			if (this._snapshot) {
				params.workspaceUri = this._snapshot.uri; //eventually consider only the workspace parameter
				params.workspace = this._snapshot.workspace;
			}
			this._dependenciesViewer = new com.ibm.team.vvc.server.core.ui.snapshots.WorkspacesAndSnapshotsViewer(params);
			dependenciesContainer.appendChild(this._dependenciesViewer.domNode);
			
			// Only show the resources tab in debug mode, see WI43979
			if(dojo.config.isDebug){
				// build resource mappings viewer
				var container = dojo.byId("resources_viewer_div");
				if (this._resourceMappingTable) {
					// refresh this view
					container.removeChild(this._resourceMappingTable.domNode);
				}
				
				var args = { configurationUri: this._snapshot.uri, lazyStart: true };
				this._resourceMappingTable = new com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer(args);
			    container.appendChild(this._resourceMappingTable.domNode);
			}
			
			this._resourceLink = new ResourceLink({
				uri: this._snapshot.getUri(),
				label: dojox.html.entities.encode(this._snapshot.getTitle()),
				around: this.iconImg,
				lazyFetch: true
	    	});
		},
		
		_setFieldNameAndValue: function(field, fieldName, value) {
			if (field) {
				PageUtil.setLinkField(field, value);
				var tr = field.parentNode.parentNode;
				var textNode = tr.children[0].firstChild;
				textNode.nodeValue = fieldName;
			}
		},
		
		setParentWorkspaceField: function(uri) {
			var parentNode = new ConfigurationUiNode({"uri": uri});
			this._parentContext.appendChild(parentNode.domNode);
		},
		
		onSave: function() {
			this.hideMessage();
			var title = this._editableTitle.value;
			var description = this._descriptionField.value;
			if (!title || title.length === 0) {
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					summary: this.messages.emptyName
				});
				return;
			}
			this.disableActions();
			var deferred;
			if (this._isCreateOperation) {
				UIUtils.showPageMessage(messages.creatingNewSnapshot);
				deferred = PageUtil.createSnapshot(title, description, this._parentUri, null, true, false);
				deferred.addCallback(this, function(params){
					this.showMessage({
						type: jazz.ui.MessageBox.STATUS_TYPES.OK,
						summary: messages.createSuccessful
					});
					this.disableSaveButton();
					this._createCompleted = true;
				});
				deferred.addErrback(this, function(error) {
					this._handleError(error, deferred.ioArgs);
					this.enableActions();
				});
			} else {
				UIUtils.showPageMessage(messages.saving);
				this._snapshot.setTitle(title);
				this._snapshot.setDescription(description);
				
				deferred = this._snapshot.save();
				deferred.addCallback(this, function(params){
					this.showMessage({
						type: jazz.ui.MessageBox.STATUS_TYPES.OK,
						summary: messages.saveSuccessful
					});
					this._editableTitle.originalValue = this._editableTitle.value;
					this._descriptionField.originalValue = this._descriptionField.value;
					this.enableActions();
					this._resourceLink.refresh();
				});
				deferred.addErrback(this, function(error) {
					this._handleError(error, deferred.ioArgs);
					this.enableActions();
				});
			}
		},
		
		onLoadError: function(response, ioArgs) {
			this._handleError(response, ioArgs);
		},
		
		enableSaveButton: function()
		{
			if (this._saveButton) {
				this._saveButton.disabled = false;
				var node = dojo.byId("dirty");
				if (!node.firstChild) {
					node.appendChild(dojo.doc.createTextNode(" *"));
				}
			}
		},
		
		disableSaveButton: function()
		{
			if (this._saveButton) {
				this._saveButton.disabled = true;
				var node = dojo.byId("dirty");
				if (node.firstChild) 
					node.removeChild(node.firstChild);
			}
		},
		
		toggleSaveButton: function()
		{
			if (this.isDirty())
				this.enableSaveButton();
			else
				this.disableSaveButton();
		},
		
		enableActions: function()
		{
			//actions should be enabled subject to permissions
			//no this.snapshot means we are in create mode
			if (this._snapshot && (!this._snapshot.permissionsLoaded || !this._snapshot.permissions.createOrModifySnapshot)) {
				if (this._snapshot.permissionsLoaded) {
					if (this._editableTitle) {
						this._editableTitle.set("title", SecurityServiceUtils.getNoPermissionMessage(this._snapshot.getProperty("controllingAreaName")));
					}
					if (this._descriptionField) {
						this._descriptionField.title = SecurityServiceUtils.getNoPermissionMessage(this._snapshot.getProperty("controllingAreaName"));
					}
				}
				this.disableActions();
				return;
			}
			
			this.toggleSaveButton();
			if (this._editableTitle)
				this._editableTitle.setDisabled(false);
			if (this._descriptionField)	
				this._descriptionField.disabled = false;
		},
		
		disableActions: function()
		{
			this.disableSaveButton();
			if (this._editableTitle)
				this._editableTitle.setDisabled(true);
			if (this._descriptionField)	
				this._descriptionField.disabled = true;
		},
		
		isDirty: function()
		{
			if (this._editableTitle && (this._editableTitle.value != this._editableTitle.originalValue))
				return true;
			else if (this._descriptionField && (this._descriptionField.value != this._descriptionField.originalValue))
				return true;
			return false;
		}
	})   
})();
