/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2011, 2014. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

(function(){

	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.WorkspaceEditor");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.InlineEditBox");
	dojo.require("jazz.util.html");
	dojo.require("jazz.ui.MessageBox");
	
	dojo.require("com.ibm.team.vvc.server.core.ui.snapshots.SnapshotsViewer");
	dojo.require("com.ibm.team.vvc.server.core.ui.snapshots.WorkspacesAndSnapshotsViewer");
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource");
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationSpace");

	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("jazz.app.ua.PageHoverHelp");
	dojo.require("jazz.app.ua.TextHoverHelp");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager");
	
	dojo.require("net.jazz.ajax.ui.PlatformUI");
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.UIUtils");
	var UIUtils = com.ibm.team.vvc.shared.web.ui.util.UIUtils;

	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
	var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	var vvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;
	
	dojo.provide("com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil");
	var ErrorUtil = com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");
	var SecurityServiceUtils = com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils;

	dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
	var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;
	
	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.deliver.DeliverUtil");
	var DeliverUtil = com.ibm.team.vvc.server.core.ui.internal.deliver.DeliverUtil;	

	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");
	var ConfigurationUiNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode");
	var ConfigurationSpaceUiNode = com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode");
	var ControllingAreaNode = com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.VvcButtonFactory");
	var vvcButtonFactory = com.ibm.team.vvc.server.core.ui.internal.util.VvcButtonFactory;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.changesets.ChangesetsExplorer");
	var ChangesetsExplorer = com.ibm.team.vvc.server.core.ui.internal.changesets.ChangesetsExplorer;
	
	dojo.require("jazz.ui.ResourceLink");
	var ResourceLink = jazz.ui.ResourceLink;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget");
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
	
	dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "WorkspaceEditorMessages");
	var messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "WorkspaceEditorMessages");
	
	var NON_BASE_SNAPSHOT = "noSnapshot";
	
	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.WorkspaceEditor", [com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget, dijit._Templated], {

		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/page/templates/WorkspaceEditor.html'),

		_editableTitle: null,
		_workspace: null,
		_parentUri: null,
		_spaceUri: null,
		_parentConfig: null,
		_snapshotComboBox: null,
		_isCreateOperation: false,
		_createCompleted: false,
		_firstRun: null,
		_notificationCenter: null,
		
		constructor: function() {
			this.messages = messages;
			this.workspaceIconUrl = dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/workspace.gif');
			this._firstRun = true;
		},
		
		postCreate: function() {
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(vvcConstants.CREATE_WORKSPACE, this, "showCreateWorkspace");
			ActionRegistry.registerAction(vvcConstants.EDIT_WORKSPACE, this, "showPage");
			
			var onresizeHandle = dojo.connect(window, "onresize", this, this.onResize);
			
			this._notificationCenter = new com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController(); 
			this.notificationCenterNode.appendChild(this._notificationCenter.domNode);

			this._initializeTabs();
		},
		
		_initializeTabs: function()
		{
			this._tabManager = new com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager();
			var class_selectedTab= "Selected";
			this._tabManager.registerTab(this._tabOverview, this.overview_content, class_selectedTab, null, vvcConstants.WORKSPACES_OVERVIEW_TAB);
			this._tabManager.registerTab(this._tabDimensions, this.dimensions_content, class_selectedTab, null, vvcConstants.DIMENSIONS_TAB);
			this._tabManager.registerTab(this._tabDependencies, this.dependencies_content, class_selectedTab, dojo.hitch(this, function() { this._dependenciesViewer.load(this);}), vvcConstants.DEPENDENCIES_TAB);
			this._tabManager.registerTab(this._tabSnapshots, this.snapshots_content, class_selectedTab, dojo.hitch(this, function() { this._snapshotsViewer.load(this);}), vvcConstants.SNAPSHOTS_TAB);
			this._tabManager.registerTab(this._tabWorkspaces, this.workspaces_content, class_selectedTab, dojo.hitch(this, function() { this._workspacesViewer.load(this);}), vvcConstants.WORKSPACES_TAB);
			this._tabManager.registerTab(this._tabChangesets, this.changesets_content, class_selectedTab, dojo.hitch(this, function() { this._changesetsViewer.refresh();}), vvcConstants.CHANGESETS_TAB);
			
			this._actionTabMap = [];
			this._actionTabMap[vvcConstants.WORKSPACES_OVERVIEW_TAB] = this._tabOverview;
			this._actionTabMap[vvcConstants.DIMENSIONS_TAB] = this._tabDimensions;
			this._actionTabMap[vvcConstants.DEPENDENCIES_TAB] = this._tabDependencies;
			this._actionTabMap[vvcConstants.SNAPSHOTS_TAB] = this._tabSnapshots;
			this._actionTabMap[vvcConstants.WORKSPACES_TAB] = this._tabWorkspaces;
			this._actionTabMap[vvcConstants.CHANGESETS_TAB] = this._tabChangesets;
			
			// Only show the resources tab in debug mode, see WI43979
			if(dojo.config.isDebug){
				this._tabManager.registerTab(this._tabResources, this.resources_content, class_selectedTab, dojo.hitch(this, function() { this._resourceMappingTable.load(this);}), vvcConstants.RESOURCES_TAB);
				this._actionTabMap[vvcConstants.RESOURCES_TAB] = this._tabResources;
			} else {
				dojo.destroy(this._tabResources);
			}
			
			dojo.connect(this._tabManager, "tabActivated", dojo.hitch(this, this._updateTab));
		},
		
		_initializeCSH:function()
		{
			if (this._ua != null)
				this._pageHeader.removeChild(this._ua.domNode);
			if (this._isCreateOperation)
				cshKey =  "com.ibm.team.vvc.server.core.page_WorkspaceEditorCreate001";
			else
				cshKey =  "com.ibm.team.vvc.server.core.page_WorkspaceEditorEdit001";	
			this._ua = new jazz.app.ua.PageHoverHelp({uaKey: cshKey});
			this._pageHeader.appendChild(this._ua.domNode);
			this._ua.domNode.style.margin = "0px 0px 0px 5px";	
			
		},
		
		showCreateWorkspace: function()
		{
			this._isCreateOperation = true;
			this._renderPage();
		},
		
		showPage: function() {
			// TODO: separate the viewer from the editor; don't morph the class based on mode.
			this._isCreateOperation = PageUtil.isCreate();
			this._renderPage();
		},
		
		_clearFields: function() {
			this._parentUri = null;
			this.hideMessage();
		},
		
		_hideNonCreationTabs: function()
		{
			this._tabDependencies.style.display = "none";
			this._tabSnapshots.style.display = "none";
			this._tabWorkspaces.style.display = "none";
			this._tabChangesets.style.display = "none";
			this._tabResources.style.display = "none";
			if (!ContextUtils.getContextUri()){
				// hide dimension tab if this is a root level create
				this._tabDimensions.style.display = "none";
			}
		},
		
		_renderPage: function() {
			this._initBreadcrumbs();
			this._initializeCSH();
			this._clearFields();
			
			var context = ContextUtils.getContextUri();
			
			if (this._isCreateOperation) {
				this._initCreateButtons();
				this._hideNonCreationTabs();

				if(this._firstRun){
					this._tabManager.showTab(this._tabOverview);
					this.firstRun = false;
				}
				
				// clear description field for new workspace
				if (this._descriptionField && this._descriptionField.value) {
					this._descriptionField.value = "";
				}

				if (context) {
					// load parent configuration
					this._parentUri = unescape(context);
					var parentConfig = new com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource();
					var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + this._parentUri;
					parentConfig.load(link, dojo.hitch(this, this.onLoadError));
					this._parentConfig = parentConfig;
					
					// set parent workspace and snapshot fields 
					var parentName = parentConfig.getTitle();
					var dimensions = [];
					var dimension;
					var separator = "\n"; // separator use by repository service
					if (parentConfig.isMutable()) {
						this.setParentWorkspaceField(this._parentUri);
						this.createParentSnapshotChoices();
						
						dimension = {};
						dimension.value = messages.oneGreaterThanDimension + separator + parentConfig.getTitle();
						dimensions.push(dimension);
						
					} else {
						this.setParentWorkspaceField(parentConfig.getParentWorkspaceUri());
						this.setParentSnapshotField(this._parentUri);
						
						dimension = {};
						dimension.value = "TimeOrder" + separator + parentName;
						dimensions.push(dimension);
						
						dimension = {};
						dimension.value = messages.oneGreaterThanDimension + separator + parentConfig.getParentWorkspaceName();
						dimensions.push(dimension);
					}
					
					// build content of dimension tab
					this._buildDimensionTab(dimensions);
					
					dojo.empty(this._controllingArea);
					var controllingAreaUiNode = new ControllingAreaNode({
						title: this._parentConfig.getProperty("controllingAreaName"),
						uri: this._parentConfig.getProperty("controllingAreaUri")
					});
					this._controllingArea.appendChild(controllingAreaUiNode.domNode);
				}
				
				// create editable workspace title
				this.createEditableTitleNode(this._titleNode, this.messages.newWorkspaceName, this.messages.clickToEdit);
			    
			} else {
				var uri = unescape(context);
				var workspace = new com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource();
				var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + uri;
				var deferred1 = workspace.load(link, dojo.hitch(this, this.onLoadError));
				
				link = VvcUtils.getVvcUri() + "/security/getAllPermissions?configurationUri=" + uri;
				var deferred2 = workspace.loadPermissions(link, dojo.hitch(this, this.onLoadError));
				
				deferred1.addCallback(this, function (param) {
					this._workspace = workspace;
					
					this._hideNonPurposeTabs();
									
					this._resourceLink = new ResourceLink({
						uri: this._workspace.getUri(),
						label: dojox.html.entities.encode(this._workspace.getTitle()),
						around: this.iconImg,
						lazyFetch: true
			    	});
				});
				deferred1.addErrback(this, function(error) {
					this._handleError(error, deferred1.ioArgs);
					this.enableActions();
				});
				
				var dl = new dojo.DeferredList([deferred1, deferred2]);
				dl.then(dojo.hitch(this, function (param) {
					if(this._isPageLoaded){
						return
					}
					this._isPageLoaded = true;
				
					this.refresh();
					this.enableActions();
					
					var hash = dojo.hash();
					if(hash){
						var hashObject = dojo.queryToObject(hash);
						this.enableActions();
						var tab = hashObject.tab;
						if(tab){
							for(var key in this._actionTabMap){
								if(tab === key){
									this._tabManager.showTab(this._actionTabMap[key]);
									return;
								}
							}
						}
						this._tabManager.showTab(this._tabOverview);
					}
				}));
				
			}
			
			this.connect(this._descriptionField, "onkeyup", function (event) {
				var descriptionInput = this._descriptionField.value;
				var validText = dojo.trim(descriptionInput);
				// A description is not necessary so we accept !validText.length
				if(validText && validText.length <= 4000){
					this.toggleSaveButton();
				} else {
					var notification = ncFactory.createError({
						title: this.messages.errorDescriptionTooLong,
						description: this.messages["errorDescriptionTooLong.explanation"],
						solution: this.messages["errorDescriptionTooLong.userAction"],
						closeOnEvent: {
							context: this._descriptionField, 
							event: "onkeyup"
						}
					});
					notification.dispatch();
				}			
				this._descriptionField.focus();
			});
			this._spaceUri = this._workspace.getSpaceUri();
			this.setSpaceField();
		},

		onSelectDimensions: function() {
			alert(messages.notSupportedYet)
		},
		
		onSelectDependancies: function() {
			var args = {};
			if (this._workspace != null) {
				args.contextUri = this._workspace.uri;
			}
			PageUtil.showPage(vvcConstants.EDIT_DEPENDENCIES, dojo.objectToQuery(args));
		},
		
		createEditableTitleNode: function(titleNode, title, tooltip){
			if (this._editableTitle) {
				this._editableTitle.setValue(title);
			} else {
				titleNode.innerHTML = jazz.util.html.escape(title);
				this._editableTitle = new dijit.InlineEditBox({
					title: tooltip, 
					autoSave: true, 
					width: "700px",
					noValueIndicator: this.getEditableTitleNodeDetails(), 
					editorParams: {maxLength: "60"},
					onFocus: dojo.hitch(this, this.hideMessage),
					onChange: dojo.hitch(this, this.onTitleChange),
				}, titleNode);
				dojo.addClass(this._editableTitle.domNode, "vvc-editor-editIndicator");

				this._editableTitle.startup();
			}
			this._editableTitle.originalValue = this._editableTitle.getValue(title);
		},

		setTitleValue: function(value){
			if(this._editableTitle){
				this._editableTitle.set('value', value);
			}
		},
		
		onTitleChange: function(e){
			this.toggleSaveButton();
		},
		
		enableSaveButton: function()
		{
			var saveButton = dojo.byId("saveToolButton");
			if (saveButton) {
				saveButton.disabled = false;
				var node = dojo.byId("dirty");
				if (!node.firstChild) {
					node.appendChild(dojo.doc.createTextNode(" *"));
				}
			}
		},
		
		disableSaveButton: function()
		{
			var saveButton = dojo.byId("saveToolButton");
			if (saveButton) {
				saveButton.disabled = true;
				var node = dojo.byId("dirty");
				if (node.firstChild) 
					node.removeChild(node.firstChild);
			}
		},
		
		toggleSaveButton: function()
		{
			if (this.isDirty())
				this.enableSaveButton();
			else
				this.disableSaveButton();
		},

		isDirty: function()
		{
			if (this._editableTitle && (this._editableTitle.value != this._editableTitle.originalValue))
				return true;
			else if (this._descriptionField && (this._descriptionField.value != this._descriptionField.originalValue))
				return true;
			return false;
		},

		getEditableTitleNodeDetails: function(){
			return "?";
		},
		
		_initCreateButtons: function() {
			this._initToolbar("createOperation");
			var node = dojo.byId("parentPickerSpan");
			if (!node.firstChild && !this._parentUri) {
				this._parentPickerButton = dojo.create("button");
				this._parentPickerButton.appendChild(dojo.doc.createTextNode(this.messages.selectParent));
				dojo.connect(this._parentPickerButton, "onclick",dojo.hitch(this, this._openPicker));
				node.appendChild(this._parentPickerButton);
			}
		},
		
		_initEditButtons: function()
		{
			if (this._parentUri == null) 
				this._initToolbar("editOperationWithNoParent");
			else
				this._initToolbar("editOperationWithParent");
		},
		
		_initToolbar: function(operation)
		{
			// all buttons are invisible by default. We select which
			// ones we want to make visible using the operation.
			if (operation === "createOperation") {
				dojo.byId("createToolButton").style.display = "";
			} else {
				var saveButton = dojo.byId("saveToolButton");
				saveButton.style.display = "";
				saveButton.setAttribute("disabled", !(this._workspace.permissionsLoaded && this._workspace.permissions.createOrModifyWorkspace));

				if (this._workspace && !this._workspace.hasPurposeDimension()) {
					// no toolbar buttons should be visible
					return;
				}

				dojo.byId("toolbarContainer").style.display = "";
				
				if (operation === "editOperationWithNoParent"){
					var button = dijit.byId("rebaseToolButton");
					button.set("style", "display: none");
				}
				
				var createConfigurationArgs = {
					uri: this._workspace.getUri(),
					spaceUri: this._workspace.getSpaceUri(),
					allowedActions: this._workspace.permissions,
					mutable: true // Workspace editor so this *should* never be false
				};
								
				var createWorkspaceCallback = dojo.hitch(this, function(){
					if(this._tabManager.currentTab && 
							this._tabManager.currentTab.key === vvcConstants.WORKSPACES_TAB){
						window.location.reload();
					} else {
						this._tabManager.showTab(this._tabWorkspaces);
					}
				});
				
				createSnapshotCallback = dojo.hitch(this, function(){
					if(this._tabManager.currentTab && 
							this._tabManager.currentTab.key === vvcConstants.SNAPSHOTS_TAB){
						window.location.reload();
					} else {
						this._tabManager.showTab(this._tabSnapshots);
					}
				});
								
				var createWorkspaceButton = vvcButtonFactory.getCreateWorkspaceButton(createConfigurationArgs, {actionCallback: createWorkspaceCallback});
				var createSnapshotButton = vvcButtonFactory.getCreateSnapshotButton(createConfigurationArgs, {actionCallback: createSnapshotCallback});
				this.editorPageToolbar.addChild(createWorkspaceButton);
				this.editorPageToolbar.addChild(createSnapshotButton);
				
				if (!(this._workspace.permissionsLoaded && this._workspace.permissions.merge)) {
					var newTitle = SecurityServiceUtils.getNoPermissionMessage(this._workspace.permissions.controllingAreaName)
					
					var button = dijit.byId("rebaseToolButton");
					button.set("enabled", false);
					button.set("title", newTitle);

					button = dijit.byId("acceptToolButton");
					button.set("enabled", false);
					button.set("title", newTitle);

					button = dijit.byId("deliverToolButton");
					button.set("enabled", false);
					button.set("title", newTitle);
				} 
			
				if(!this._workspace.getParentSnapshotUri()){
					this.compareSnapshotToolButton.set("visible", false);
				}
				
				if(!this._workspace.getParentWorkspaceUri()){
					dijit.byId("deliverToolButton").set("visible", false);
					dijit.byId("compareParentToolButton").set("visible", false);
				}
				
			}
		},
		
		_openPicker:function(e) {
			var self = this;
			var picker = new com.ibm.team.vvc.shared.web.ui.picker.WorkspacePickerDialog({
				"newButtonDisabled" : true,
			});
			
			picker.onOk = function(configuration) {
				self._clearFields();
				self._parentUri = configuration.uri;
				var config = new com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource();
				self._parentConfig = config;
				var link = VvcUtils.getVvcUri() + "/repository/configuration?uri=" + self._parentUri;
				config.load(link, dojo.hitch(self, self.onLoadError));
				self.setSpaceField();
				
				if (configuration.type == "workspace") {
					self.setParentWorkspaceField(configuration.uri);
					self.createParentSnapshotChoices();
				} else {
					self.setParentSnapshotField(configuration.uri);
					self.setParentWorkspaceField(config.getParentWorkspaceUri());
					self._snapshotComboBox = null;
				}
			};
		},
		
		getContextQuery: function() {
			if (this._workspace) {
				var uri = this._workspace.getUri();
				if (uri) {
					var query = {};
					query.contextUri= uri;
					query.breadcrumb = this._getEncodedWorkspaceTitle();
					query.redirectUri = window.location.href;
					return dojo.objectToQuery(query);
				}
			}
		},

		onRebase: function() {
			var query = this.getContextQuery();			
			PageUtil.showPage(vvcConstants.EDIT_BASE_CONFIGURATION, query);
		},
		
		onDeliver: function() {
			var args = {};
			if (this._workspace) {
				args.sourceUri = this._workspace.getUri();
				args.targetUri = this._workspace.getParentWorkspaceUri();
				args.refererUri = window.location.href;
				args.goToStep2 = true;
				
				DeliverUtil.startDeliverUi(args);
			}
		},
		
		onAccept: function() {
			var args = {};
			if (this._workspace) {
				args.sourceUri = this._workspace.getParentWorkspaceUri();
				args.targetUri= this._workspace.getUri();
				args.refererUri = window.location.href;
				args.goToStep2 = true;
				
				DeliverUtil.startDeliverUi(args);
			}
		},
		
		onCompareWithParentSnapshot: function() {
			var args = {};
			if (this._workspace) {
				args.sourceUri = this._workspace.getUri();
				args.targetUri= this._workspace.getParentSnapshotUri();
				args.refererUri = window.location.href;
				args.operation = Constants.DELIVER_OPERATION_COMPARE;
				args.goToStep2 = false;
				
				DeliverUtil.startDeliverUi(args);
			}
		},
		
		onCompareWithParentWorkspace: function() {
			var args = {};
			if (this._workspace) {
				args.targetUri = this._workspace.getUri();
				args.sourceUri= this._workspace.getParentWorkspaceUri();
				args.refererUri = window.location.href;
				args.operation = Constants.DELIVER_OPERATION_COMPARE;
				args.goToStep2 = false; 
				
				DeliverUtil.startDeliverUi(args);
			}
		},
		
		_getEncodedWorkspaceTitle: function() {
			return encodeURIComponent(this._workspace.getTitle());
		},
		
		refresh: function() {
			if (!(this._workspace.permissionsLoaded && this._workspace.permissions.updateDependencies)) {
				this._addDependenciesButton.set("enabled", false);
				this._addDependenciesButton.set("title", SecurityServiceUtils.getNoPermissionMessage(this._workspace.permissions.controllingAreaName));
			}
			
			if (this._workspace.isArchived()) {
				alert(messages.unableToOpenArchived);
				window.location.assign(VvcUtils.getVvcUri());
				return;
			}
			this._parentUri = this._workspace.getParentSnapshotUri();
			if (!this._parentUri) {
				// this workspace has no parent snapshot
				this._parentUri = this._workspace.getParentWorkspaceUri();
			}
			this._initEditButtons();
			this.setParentWorkspaceField(this._workspace.getParentWorkspaceUri());
			this.setParentSnapshotField(this._workspace.getParentSnapshotUri());
			this.setSpaceField();
			//this is not called during a when _isCreateOperation, so just look at the _workspace
			var controllingAreaUiNode = new ControllingAreaNode({
				title: this._workspace.getProperty("controllingAreaName"),
				uri: this._workspace.getProperty("controllingAreaUri")
			});
			this._controllingArea.appendChild(controllingAreaUiNode.domNode);
			
			// create and set title
			var title = this._workspace.getTitle();
			this.createEditableTitleNode(this._titleNode, title, this.messages.clickToEdit);
			
			// set description text
			this._descriptionField.value = this._workspace.getDescription();
			this._descriptionField.originalValue = this._descriptionField.value;
			
			// build dimension viewer
			this._buildDimensionTab(this._workspace.getDimensions());
			
			// build dependency viewer
			var dependenciesContainer = dojo.byId("dependencies_viewer_div");
			if (this._dependenciesViewer) {
				// refresh this view
				var node = this._dependenciesViewer.domNode;
				dependenciesContainer.removeChild(node);
			}
			
			var params = { style: 2, lazyStart: true };
			if (this._workspace) {
				params.workspaceUri = this._workspace.uri; // consider removing
				params.workspace = this._workspace;
			}
			this._dependenciesViewer = new com.ibm.team.vvc.server.core.ui.snapshots.WorkspacesAndSnapshotsViewer(params);
			dependenciesContainer.appendChild(this._dependenciesViewer.domNode);
			
			// build snapshots viewer
			var container = dojo.byId("snapshots_viewer_div");
			if (this._snapshotsViewer) {
				container.removeChild(this._snapshotsViewer.domNode);
			}
			
			var args = { workspace: this._workspace, style: 0, lazyStart: true };
			this._snapshotsViewer = new com.ibm.team.vvc.server.core.ui.snapshots.SnapshotsViewer(args);
		    container.appendChild(this._snapshotsViewer.domNode);

		    // build workspaces viewer
			var container = dojo.byId("workspaces_viewer_div");
			if (this._workspacesViewer) {
				container.removeChild(this._workspacesViewer.domNode);
			}
			
			var args = { workspace: this._workspace, style: 2, lazyStart: true };
			this._workspacesViewer = new com.ibm.team.vvc.server.core.ui.snapshots.SnapshotsViewer(args);
		    container.appendChild(this._workspacesViewer.domNode);
    		
			// build changesets viewer
			var container = dojo.byId("changesets_viewer_div");
			if (this._changesetsViewer) {
				container.removeChild(this._changesetsViewer.domNode);
			}

			this._changesetsViewer = new ChangesetsExplorer({
				configurationUri: this._workspace.getUri(),
				notificationCenter: this._notificationCenter
			});
		    container.appendChild(this._changesetsViewer.domNode);
			
			// Only show the resources tab in debug mode, see WI43979
		    if(dojo.config.isDebug){
				// build resource mappings viewer
				var container = dojo.byId("resources_viewer_div");
				if (this._resourceMappingTable) {
					// refresh this view
					container.removeChild(this._resourceMappingTable.domNode);
				}
				
				var args = { configurationUri: this._workspace.uri, lazyStart: true };
				this._resourceMappingTable = new com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer(args);
			    container.appendChild(this._resourceMappingTable.domNode);
		    }
		},
		
		createParentSnapshotChoices: function() {
			if (this._parentContext.firstChild) {
				this._parentContext.removeChild(this._parentContext.firstChild);
			}
			var select = dojo.create("select", null, this._parentContext);
			this._snapshotComboBox = select;

			// add create snapshot automatically option
			var option = dojo.create("option", {
				value: "autoCreateBaseSnapshot",
				selected: true
			});
			option.appendChild(dojo.doc.createTextNode(this.messages.autoCreate));
			select.appendChild(option);
			option.title = this.messages.autoCreateTooltip;
			
			var uri = VvcUtils.getVvcUri() + "/repository/snapshots?parentWorkspace=" + escape(this._parentUri);
			var args = {
				url: uri,
				handleAs: "json",
				headers: {
					Accept: "application/json;application/rdf+json;text/rdf+json;text/json"
				},
			};
			var deferred = jazz.client.xhrGet(args);
			
			// create options for the select box
			deferred.addCallback(this, function (snapshots) {
				for (var i = 0; i < snapshots.length; i++){
					var snapshotEntry = snapshots[i];
					for (var snapshotUri in snapshotEntry) {
						var snapshot = snapshotEntry[snapshotUri];
						option = dojo.create("option", {
							value: snapshotUri
						});

						// create snapshot name entry
						var titleNode = snapshot[Constants.TITLE];
						if (titleNode && titleNode[0]) {
							var name = titleNode[0].value;
							if (name) {
								option.appendChild(dojo.doc.createTextNode(name));
								select.appendChild(option);
							}
						}

						// create tooltip
						var createdNode = snapshot[Constants.CREATED];
						if (createdNode && createdNode[0]) {
							var created = createdNode[0].value;
							if (created) {
								var createdDate = dojo.date.stamp.fromISOString(created);
								var date = dojo.date.locale.format(createdDate, {formatLength: "medium"});
								var text = dojo.string.substitute(this.messages.createdDate, [date]);
								
								// append description if not empty
								var descriptionNode = snapshot[Constants.DESCRIPTION];
								if (descriptionNode && descriptionNode[0]) {
									var desc = descriptionNode[0].value;
									if (desc) {
										text += " \n" + this.messages.description + " " + desc;
									}
								}
								option.title = text;
							}
						}
					}
				}

				select.appendChild(option);
				option.title = this.messages.withoutBaseSnapshotTooltip;
			});
			
			deferred.addErrback(this, function(error) {
				this._handleError(error, deferred.ioArgs);
				this.enableActions();
				
								
				// add none option for no snapshot in last entry
				option = dojo.create("option", {
					value: NON_BASE_SNAPSHOT
				});
				option.appendChild(dojo.doc.createTextNode(this.messages.none));
				select.appendChild(option);
				option.title = this.messages.withoutBaseSnapshotTooltip;
			});
		},
		
		setParentSnapshotField: function(snapshotUri) {
			dojo.empty(this._parentContext);
			if(snapshotUri){
				var snapshotUiNode = new ConfigurationUiNode({uri: snapshotUri});			
				this._parentContext.appendChild(snapshotUiNode.domNode);
			} else {
				this._parentContext.appendChild(dojo.doc.createTextNode(messages.none));
			}
		},
		
		setParentWorkspaceField: function(workspaceUri) {
			dojo.empty(this._parentWorkspace);
			if(workspaceUri){
				var workspaceUiNode = new ConfigurationUiNode({uri: workspaceUri});
				this._parentWorkspace.appendChild(workspaceUiNode.domNode);
			} else {
				this._parentWorkspace.appendChild(dojo.doc.createTextNode(messages.none));
			}
		},
		
		setSpaceField: function() {
			dojo.empty(this._configurationSpace);
			var spaceUiNode = new ConfigurationSpaceUiNode({
				uri: this._spaceUri
			});
			this._configurationSpace.appendChild(spaceUiNode.domNode);
		},
		
		_buildDimensionTab: function(dimensions) {
			// create table
			var columnData = [{ label: this.messages.name }, { label: this.messages.value }];
			var container = this._dimensionContainerNode;
			if (container && container.firstChild) {
				container.removeChild(container.firstChild);
			}
			
			// create table header
			var table = new jazz.ui.StyledTable({
				trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS,
				columns: columnData
			});
			table.domNode.style.width = "100%";
			container.appendChild(table.domNode);
			
			// Now add the rows
			if (dimensions && dimensions.length > 0) {
				for (var i = 0; i < dimensions.length; i++){
					var nameValuePair = dimensions[i].value;
					var index = nameValuePair.indexOf("\n");
					if (index === -1) {
						continue;
					}
					
					var name = nameValuePair.substring(0, index);
					var value = nameValuePair.substring(index + 1);
					
					if("Time Order" === name){
						var time = new Date(value);
						value = time.toLocaleDateString() + " " + time.toLocaleTimeString();
						name = messages.timeOrderDimension;
					} else if("Purpose" === name){
						name = name = messages.purposeDimension;
					}

					var tr = dojo.create("tr", null, table.tbody);
					var titleTd = dojo.create("td", {
						innerHTML: name
					}, tr);
					var valueTd = dojo.create("td", {
						innerHTML: jazz.util.html.escape(value)
					}, tr);
				}
			}
			
			return table;
		},
		
		onSave: function() {
			this.hideMessage();
			var title = this._editableTitle.value;
			var description = this._descriptionField.value;
			if (!title || title.length === 0) {
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					summary: this.messages.emptyName
				});
				return;
			}
			
			var deferred;
			this.disableActions();
			if (this._isCreateOperation) {
				UIUtils.showPageMessage(messages.creatingNewWorkspace);
				if (this._spaceUri == null && this._parentConfig != null) {
					this._spaceUri = this._parentConfig.getSpaceUri();
				}
				
				if (this._parentConfig && this._parentConfig.isMutable() && this._snapshotComboBox) {
					// handle create workspace with parent workspace context
					var index = this._snapshotComboBox.selectedIndex;
					if (index == 0) {
						// create new snapshot and new workspace
						var baseSnapshotName = this._parentConfig.getTitle();
						deferred = PageUtil.createSnapshot(baseSnapshotName, "",  this._parentConfig.getUri(), this._spaceUri, true, true);
						deferred.addCallback(this, function(params){
							var baseSnapshotUri = params;
							this._createWorkspace(title, description, baseSnapshotUri);
						});
						deferred.addErrback(this, function(error) {
							var errorDetails = ErrorUtil.getErrorDetails(error);
							if (vvcConstants.ERROR_CODE_EXISTS === errorDetails.errorSubStatus) {
								this.showMessage({
									type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
									summary: this.messages.duplicateSnapshotForConfigurationName
								});
							} else {
								this._handleError(error, deferred.ioArgs);
							}							
							
							this.enableActions();
						});
					} else {
						// create new workspace with selected existing snapshot
						var snapshot = this._snapshotComboBox.options[index];
						if (snapshot.value === NON_BASE_SNAPSHOT) {
							this._createWorkspace(title, description, this._parentUri);
						} else {
							this._createWorkspace(title, description, snapshot.value);
						}
					}
				} else {
					this._createWorkspace(title, description, this._parentUri);
				}
				
			} else {
				UIUtils.showPageMessage(messages.saving);
				var saveButton = dojo.byId("saveToolButton");
				this._workspace.setTitle(title);
				this._workspace.setDescription(description);
				deferred = this._workspace.save();
				deferred.addCallback(this, function(params){
					this.showMessage({
						type: jazz.ui.MessageBox.STATUS_TYPES.OK,
						summary: messages.saveSuccessful
					});
					this._editableTitle.originalValue = this._editableTitle.value;
					this._descriptionField.originalValue = this._descriptionField.value;
					this.enableActions();
					this._resourceLink.refresh();
				});
				deferred.addErrback(this, function(error) {
					this._handleError(error, deferred.ioArgs);
					this.enableActions();
				});
			}
		},
		
		_createWorkspace: function(title, description, baseSnapshotUri) {
			deferred = PageUtil.createWorkspace(title, description, baseSnapshotUri, this._spaceUri, true, false);
			deferred.addCallback(this, function(params){
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.OK,
					summary: messages.createSuccessful
				});
				this.disableActions();
				this._createCompleted = true;
			});
			deferred.addErrback(this, function(error) {
				this._handleError(error, deferred.ioArgs);
				this.enableActions();
			});
		},
		
		onLoadError: function(response, ioArgs) {
			this._handleError(response, ioArgs);
		},
		
		enableActions: function()
		{
			// actions should be enabled subject to permissions
			if (this._workspace && (!this._workspace.permissionsLoaded || !this._workspace.permissions.createOrModifyWorkspace)) {
				this._editableTitle.set("title", SecurityServiceUtils.getNoPermissionMessage(this._workspace.permissions.controllingAreaName));
				this._descriptionField.title = SecurityServiceUtils.getNoPermissionMessage(this._workspace.permissions.controllingAreaName);				
				this.disableActions();
				return;
			}
			//if there was a way to refresh the editor, this would be necessary: this._editableTitle.set("title", this.messages.clickToEdit); similar for description field
			
			var createButton = dojo.byId("createToolButton");
			if (createButton) {
				createButton.disabled = false;
			}
			this.toggleSaveButton();

			if (this._editableTitle)
				this._editableTitle.setDisabled(false);
			if (this._descriptionField)
				this._descriptionField.disabled = false;
			if (this._parentPickerButton)
				this._parentPickerButton.disabled = false;
		},
		
		disableActions: function()
		{
			var createButton = dojo.byId("createToolButton");
			if (createButton) {
				createButton.disabled = true;
			}
			this.disableSaveButton();

			if (this._editableTitle)
				this._editableTitle.setDisabled(true);
			if (this._descriptionField)
				this._descriptionField.disabled = true;
			if (this._parentPickerButton)
				this._parentPickerButton.disabled = true;
		},
		
		_hideNonPurposeTabs: function()
		{
			if (this._workspace && !this._workspace.hasPurposeDimension()) {
				this._tabSnapshots.style.display = "none";
				this._tabWorkspaces.style.display = "none";
				this._tabChangesets.style.display = "none";
				
				delete this._actionTabMap[vvcConstants.SNAPSHOTS_TAB];
				delete this._actionTabMap[vvcConstants.WORKSPACES_TAB];
				delete this._actionTabMap[vvcConstants.CHANGESETS_TAB];
			}
		}
	})   
})();
